import { Column, CreateDateColumn, Entity, OneToMany, PrimaryColumn } from "typeorm";
import { apiPermission } from "./api_permission";

@Entity()
export class api {
  @PrimaryColumn({ generated: "increment", type: "int" })
  id: number;

  @Column({ type: "varchar", length: 255, unique: true, select: false })
  token: string;

  @Column({ type: "varchar", length: 255 })
  title: string;

  @CreateDateColumn()
  createdAt: Date;

  @Column({ type: "datetime", nullable: true })
  lastUsage?: Date;

  @Column({ type: "datetime", nullable: true })
  expiry?: Date;

  @OneToMany(() => apiPermission, (apiPermission) => apiPermission.api)
  permissions: apiPermission[];
}
